 
#include <Arduino.h>
#include <avr/pgmspace.h> == 0


#include "kasoku.h"
#include "VVVF_sound.h"
#include "motor_func.h"


//吊りかけ、VVVF
#include "test23_loud.h"//吊りかけ音のかけら　test23 低音側
#define WAV_DATA1 test23_data
#define  WAV_LENGTH1 test23_length
#define REF_WAVE_FREQ1 (1000000 / (WAV_LENGTH1 * 62.5))

#define WAV_DATA2 test23_data
#define  WAV_LENGTH2 test23_length
#define REF_WAVE_FREQ2 (1000000 / (WAV_LENGTH2 * 62.5))

#define SHIFT_PWM 5

#define  COUNT_CONSTANTSPEED   33 
//吊りかけ、VVVF ここまで

//Diesel 注意:WAVはヘッダ無しを使用のこと！
#include "D205_16000_WAV3_unsigned_8bit.h"//大井川鉄道　アプトdiesel音
#define WAV_DATA_DL D205_16000_WAV3_unsigned_8bit_data
#define  WAV_LENGTH_DL D205_16000_WAV3_unsigned_8bit_length
#define REF_WAVE_FREQ_DL (1000000 / (WAV_LENGTH_DL * 62.5))

#define SHIFT_PWM_DL 8

#define  COUNT_CONSTANTSPEED_DL   33*10 /* 33d=1sec  */
//diesel ここまで

//共通
#define  THRESHOLD_RATIO       40 /* ノッチオフの加減速しきい値 */

//VVVF配列
int uplimit; //VVVF配列の上限
int kasoku[15][8];//VVVF配列
#define CARRER_FREQ 16000


int current_period1 =(double)1000000 / CARRER_FREQ;//VVVF周期

//吊りかけ、VVVF
volatile unsigned int pwm_state1 = 0;
volatile unsigned int pwm_state2 = 20;
unsigned int pwm_state1_ret = WAV_LENGTH1 << SHIFT_PWM;
unsigned int pwm_state2_ret = WAV_LENGTH2 << SHIFT_PWM;

unsigned int pwm_add1 = 0;
unsigned int pwm_add2 = 20;
unsigned int old_pwm_add1 = 0;
unsigned int old_pwm_add2 = 10;
//吊りかけ、VVVF　ここまで

//diesel 
volatile unsigned long pwm_state_dl = 0;

unsigned long pwm_add_dl = 0;
boolean dl_flag = false; //true:DL,false:EL
//diesel ここまで

//共通
unsigned int pwm_shift = 8;

int current_duty_a = 0;

int gAccRatio = 20;
int gDecRatio = 20;
int gNotchSpdCount = 0;

uint8_t SoundSwitch = 0;
uint8_t SoundState = 1;
uint8_t SoundNotch = 0;
uint8_t SoundVolume = 0;
long gVVVFLPF_buf = 0;

// float PrevSpeed = 0;
float PrevSpeedCalc = 0;    // 計算用とサウンド用を分ける　2020-5-9 TRAINO
float PrevSpeedSound = 0;

boolean accel_flag = false;

void VVVF_Setup()
{
  //debug
  //pinMode(7, OUTPUT);
  
  //PWM出力ピン D9を出力にセット
  pinMode(VVVF_SOUND_PIN, OUTPUT);

  //31KHzに設定（初期設定でPhaseCorrectPWMモードになっていると思う）
  //D9,D10  キャリア周期:31kHz(分周無し）
  TCCR1B &= B11111000;
  TCCR1B |= B00000001;

  //出力の設定
  if(VVVF_SOUND_PIN == 9)
  {
    TCCR1A |= _BV(COM1A1);
  }
  else //10
  {
    TCCR1A |= _BV(COM1B1);
  }
  
  //interrupt設定
  TIMSK1 = _BV(TOIE1);
}

void VVVF_SetCV(uint8_t iNo, uint8_t inData)
{
  switch(iNo)
  {
	case 3:
		
		if( inData > 16)
		{
			gAccRatio = 255;
		}
		else
		{
			gAccRatio = inData * 16;
		}
	
		if( gAccRatio <= 0)
	  	{
	  		gAccRatio = 1;
	  	}
		
		break;
	case 4:
		if( inData > 16)
		{
			gDecRatio = 255;
		}
		else
		{
			gDecRatio = inData * 16;
		}
		
		if( gDecRatio <= 0)
	  	{
	  		gDecRatio = 1;
	  	}
  		break;
  case 47:
    if(inData > 9)
    {
      inData = 9;
    }
    SoundSwitch = inData;
    break;
  case 48:
    //１：レールジョイント音、２：ブレーキ音、４：吊りかけリバーブ効果
    SoundState = inData;
    break;
  case 49:
    if(inData > 2)
    {
      inData = 2;
    }
    SoundNotch = inData;
    break;
  case 50:
    if( inData > 8)
    {
      inData = 8;//0:min(no sound) ~ 8:max
    }
    SoundVolume = inData;
    break;
  }
}

extern int VVVF_Cont(int inPWMFreq,int speedcmd, uint8_t inF2Flag)
{
  uint16_t gSpeedCmd_temp = 0;  // TRAINO
  //外向けの関数 返り値は gSpeedCmdとする。
  //VVVF control 京急とそれ以外で分ける
  // // 2020/4/18 KEIKYU2100 / TRAINO
  // // 2020/5/9 KEIKYU2100 / TRAINO
  //2020/5/14 DL fujigaya2
  switch(SoundSwitch)
  {
    case 0:
      //no sound
      dl_flag = false;
      pwm_shift = 8;//音量０
      gSpeedCmd_temp = speedcmd;
      break;
    case 1:
      //DL
      //DieselFlag設定
      dl_flag = true;
      VVVF_Cont_DL(inPWMFreq, inF2Flag);
      gSpeedCmd_temp = speedcmd;
      break;
    case 3:
    case 5:
      //京急
      dl_flag = false;
      gSpeedCmd_temp = VVVF_Cont_KQ(inPWMFreq, inF2Flag) * 10 / 25;//inoから移設。
      break;
    default:
      //その他EL
      dl_flag = false;
      VVVF_Cont_Normal(inPWMFreq, inF2Flag);
      gSpeedCmd_temp = speedcmd;
      break;  
  }
  return gSpeedCmd_temp;
}

void VVVF_Cont_Normal(int inPWMFreq, uint8_t inF2Flag)
{
  uint16_t aPWMRef = 0;

  //LPF
  aPWMRef = MOTOR_LPF(inPWMFreq, 32, &gVVVFLPF_buf);
  
  //int to float
  float instruct_speed = (float)(aPWMRef * 4);//change from 256 to 1023
  float speed_step = 0;
  
  if(inPWMFreq == 0)
  {
    accel_flag = false;
    PrevSpeedCalc = 0;
  }
  else if( (PrevSpeedCalc - instruct_speed) < -1 )
  {
    //Acceleration
    accel_flag = true;
    speed_step = (abs(instruct_speed - PrevSpeedCalc) / gAccRatio) + 1;
    
    PrevSpeedCalc += speed_step ;
    if (PrevSpeedCalc > instruct_speed)
    {
      PrevSpeedCalc = instruct_speed;
      
    }
    
    //ノッチオフの音を止めるタイマ
    gNotchSpdCount = COUNT_CONSTANTSPEED;
  }
  else if( (PrevSpeedCalc - instruct_speed) > 1 )
  {
    //Decelerat
    accel_flag = false;
    speed_step = (abs(instruct_speed - PrevSpeedCalc) / gDecRatio) + 1;
    PrevSpeedCalc -= speed_step;
    if (PrevSpeedCalc < instruct_speed)
    {
      PrevSpeedCalc = instruct_speed;
    }
    
    gNotchSpdCount = 0;
  }
  else
  {
    //Constant speed
    
    
    if( gNotchSpdCount > 0)
    {
      gNotchSpdCount--;
      accel_flag = true;
    }
    else
    {
      accel_flag = false;
    }
    
  }
  /* 
  ノッチオフ無効(0)時はアクセルフラグを常時有効（減速でオフにさせない) 
  ノッチオフ自動(1)時はアクセルフラグを自動制御(加速終了後指定時間でオフ)
  ノッチオフ手動(2)時はアクセルフラグを手動操作
  */
  
  if (SoundNotch == 2)
  {
    if (inF2Flag == 0)
    {
      accel_flag = true;
    }
    else
    {
      accel_flag = false;
    }
    
  }
  else
  {
    //何もしない
  }
  PrevSpeedSound = PrevSpeedCalc; // add
  VVVF_Freq((int)PrevSpeedCalc);
  /* 加減速管理 */
  if( (PrevSpeedCalc != 0) && ((accel_flag == true) || ( SoundNotch == 0)))
  {
    if(SoundVolume > (8 - pwm_shift))
    {
      pwm_shift --;
    }
  }
  else
  {
    //pwm_shift == 10で音量0
    if(pwm_shift < 8)
    {
      pwm_shift ++;
    }
  }
}

// 
// VVVF_Cont_KQ
// 2020/4/18 KEIKYU2100　/ TRAINO
// 2020/5/9 KEIKYU2000　/ TRAINO  スロットル絞ってもすぐに止めない
//      return Motor speed
//
int VVVF_Cont_KQ(int inPWMFreq, uint8_t inF2Flag)
{
	uint16_t aPWMRef = 0;
	//LPF
	aPWMRef = MOTOR_LPF(inPWMFreq, 32, &gVVVFLPF_buf);  // これは moter funcで定義
	//int to float
  unsigned short instruct_speed = (unsigned short)(aPWMRef * 4);  //change from 256 to 1023　// 2020/4/18 KEIKYU2100
  unsigned short speed_step = 0;
  
  if(( inPWMFreq == 0)&&(PrevSpeedCalc == 0))  // 速度指令０かつ現在の速度０でサウンド停止
  {
    accel_flag = false;
    PrevSpeedCalc = 0;
    PrevSpeedSound = 0;
  }
  else if( instruct_speed > PrevSpeedCalc )  
  {
    accel_flag = true;
    speed_step = ((instruct_speed - PrevSpeedCalc) / gAccRatio) + 1;
  	
    PrevSpeedCalc += speed_step ;
    if (PrevSpeedCalc > instruct_speed)
    {
      if(PrevSpeedCalc > (instruct_speed+speed_step))
            PrevSpeedCalc -= speed_step;
      else
            PrevSpeedCalc = instruct_speed;
    }
  	PrevSpeedSound = PrevSpeedCalc;
  	//ノッチオフの音を止めるタイマ
  	gNotchSpdCount = COUNT_CONSTANTSPEED;
  }
  else if( PrevSpeedCalc > instruct_speed)
  {
    //Deceleration
    accel_flag = false;
    speed_step = ((PrevSpeedCalc -instruct_speed) / gDecRatio) + 1;
    // ドレミファオーバー
    if(PrevSpeedCalc > 40) 
    {
      if(PrevSpeedCalc > speed_step) 
        PrevSpeedCalc -= speed_step; 
      else 
        PrevSpeedCalc=40;
      PrevSpeedSound =PrevSpeedCalc;
      if (PrevSpeedCalc < 40) 
        PrevSpeedSound = 40; 
    }
    // ドレミファのとき
    else  {
      if(PrevSpeedCalc > speed_step) {
        PrevSpeedCalc -= speed_step; 
        PrevSpeedSound = 40;  //　サウンドのみ下げない
      }
      else { 
        PrevSpeedCalc=0;     
        PrevSpeedSound = 0; 
      }
    }
    gNotchSpdCount = 0;
  }
  else
  {
  	//Constant speed  	
  	
  	if( gNotchSpdCount > 0)
  	{
  		gNotchSpdCount--;
	    accel_flag = true;
  	}
  	else
  	{
	    accel_flag = false;
  	}
  	
  }
	
	/* 
	ノッチオフ無効(0)時はアクセルフラグを常時有効（減速でオフにさせない) 
	ノッチオフ自動(1)時はアクセルフラグを自動制御(加速終了後指定時間でオフ)
	ノッチオフ手動(2)時はアクセルフラグを手動操作
	*/
	
	if (SoundNotch == 2)
	{
		if (inF2Flag == 0)
		{
			accel_flag = true;
		}
		else
		{
			accel_flag = false;
		}
		
	}
	else
	{
		//何もしない
	}

  VVVF_Freq((int)PrevSpeedSound);
	/* 加減速管理 */
	if( (PrevSpeedCalc != 0) && ((accel_flag == true) || ( SoundNotch == 0)))
	{
    if(SoundVolume > (8 - pwm_shift))
    {
      pwm_shift --;
    }
	}
	else
	{
    //pwm_shift == 10で音量0
    if(pwm_shift < 8)
    {
      pwm_shift ++;
    }  
	}

  return ((uint16_t) PrevSpeedCalc );
 
}

void VVVF_Cont_DL(int inPWMFreq, uint8_t inF2Flag) 
{
  uint16_t aPWMRef = 0;

  //LPF
  aPWMRef = MOTOR_LPF(inPWMFreq, 32, &gVVVFLPF_buf);
  
  //int to float
  float instruct_speed = (float)(aPWMRef * 4);//change from 256 to 1023
  float speed_step = 0;
  boolean flag_sound_on = false;//on:true,off:false
  boolean flag_sound_accel = true;//on: accel,off:decel
  int sound_speed;
  
  if(inPWMFreq == 0)
  {
    //accel_flag = false;
    accel_flag = true;
    PrevSpeedCalc = 0;
  }
  else if( (PrevSpeedCalc - instruct_speed) < -1 )
  {
    //Acceleration
    accel_flag = true;
    speed_step = (abs(instruct_speed - PrevSpeedCalc) / gAccRatio) + 1;
    
    PrevSpeedCalc += speed_step ;
    if (PrevSpeedCalc > instruct_speed)
    {
      PrevSpeedCalc = instruct_speed;
    }
    
    //ノッチオフの音を止めるタイマ
    gNotchSpdCount = COUNT_CONSTANTSPEED_DL;
  }
  else if( (PrevSpeedCalc - instruct_speed) > 1 ) 
  {
    //Deceleration
    accel_flag = false;
    speed_step = (abs(instruct_speed - PrevSpeedCalc) / gDecRatio) + 1;
    PrevSpeedCalc -= speed_step;
    if (PrevSpeedCalc < instruct_speed)
    {
      PrevSpeedCalc = instruct_speed;
    }
    
    gNotchSpdCount = 0;
  }
  else
  {
    //Constant speed
    
    
    if( gNotchSpdCount > 0)
    {
      gNotchSpdCount--;
      accel_flag = true;
    }
    else
    {
      accel_flag = false;
    }
    
  }


  switch(SoundNotch)
  {
    case 0:
      //停止:アイドル
      //加速：スピード比例（加速配列）
      //減速：スピード比例（加速配列）
      if(PrevSpeedCalc == 0)
      {
        //停止時
        flag_sound_on = true;
        flag_sound_accel = true;        
        sound_speed = 0;
      }
      else if(accel_flag == true)
      {
        //加速時             
        flag_sound_on = true;
        flag_sound_accel = true;        
        sound_speed = PrevSpeedCalc;
      }
      else
      {
        //減速時
        flag_sound_on = true;
        flag_sound_accel = true;
        sound_speed = PrevSpeedCalc;
      }
      break;
    case 1:
      //停止:アイドル
      //加速：スピード比例（加速配列）
      //減速：無音
      if(PrevSpeedCalc == 0)
      {
        //停止時
        flag_sound_on = true;
        flag_sound_accel = true;
        sound_speed = 0;
      }
      else if(accel_flag == true)
      {
        //加速時             
        flag_sound_on = true;
        flag_sound_accel = true;
        sound_speed = PrevSpeedCalc;
      }
      else
      {
        //減速時
        flag_sound_on = false;             
        flag_sound_accel = true;
        sound_speed = 0;
      }
      break;
    case 2:
      //停止:アイドル
      //加速：スピード比例（加速配列）
      //減速：スピード比例（減速配列）
      if(PrevSpeedCalc == 0)
      {
        //停止時
        flag_sound_on = true;
        flag_sound_accel = true;
        sound_speed = 0;
      }
      else if(accel_flag == true)
      {
        //加速時             
        flag_sound_on = true;
        flag_sound_accel = true;
        sound_speed = PrevSpeedCalc;
      }
      else
      {
        //減速時
        flag_sound_on = true;
        flag_sound_accel = false;
        sound_speed = PrevSpeedCalc;
      }
      break;
    default:
      //無音
      flag_sound_on = false;
      break;
  }


  if(inF2Flag != 0)
  {
    //SoundOff設定時
    flag_sound_on = false;
  }

  //WAV制御
  VVVF_Freq_DL((int)sound_speed,flag_sound_accel);

  //音量管理
  if(flag_sound_on == true)
  {
    //音を大きくする。
    if(SoundVolume > (8 - pwm_shift))
    {
      pwm_shift --;
    }
  }
  else
  {
    //音を小さくする。
    //pwm_shift == 10で音量0
    if(pwm_shift < 8)
    {
      pwm_shift ++;
    }
  }
}


int VVVF_Freq( int inPWMFreq)
{
  //VVVF Freq部分
  double pwm_freq1 = 440;
  double pwm_freq2 = 440;
  
  for(int i = 0;i < uplimit;i++)
  {
    if ( (kasoku[i][0] <= inPWMFreq ) and ( inPWMFreq <= kasoku [i][1]))
    {
      //音色側
      //周波数１
      pwm_freq1 = (double)kasoku[i][2]
               + (double)(kasoku[i][3] - kasoku[i][2]) / (double)(kasoku [i][1] - kasoku [i][0])
               * (double)(inPWMFreq - kasoku [i][0]);
      pwm_freq2 = (double)kasoku[i][4]
               + (double)(kasoku[i][5] - kasoku[i][4]) / (double)(kasoku [i][1] - kasoku [i][0])
               * (double)(inPWMFreq - kasoku [i][0]);
    }  
  }
  pwm_add1 = (pwm_freq1 * pow(2,SHIFT_PWM)) / REF_WAVE_FREQ1;
  pwm_add2 = (pwm_freq2 * pow(2,SHIFT_PWM)) / REF_WAVE_FREQ2;

  if((SoundState & 4) != 0)
  {
    //33msリバーブ
    pwm_add2 = old_pwm_add1 * 1;
  }
  else
  {
    //通常の和音
  }
  old_pwm_add1 = pwm_add1;
  old_pwm_add2 = pwm_add2;
  

  //コーラス？
  //pwm_add2 =pwm_add1*0.999;
  //pwm_add3 =pwm_add1*0.998;
  //pwm_add2 =pwm_add1*2;
  //pwm_add3 =pwm_add1*3;

  return 0;
}

int VVVF_Freq_DL( int inPWMFreq,boolean flag_sound_accel)
{
  //VVVF Freq部分
  //DL Ver
  //200517 変更
  double pwm_freq1 = 440;
  double pwm_freq_out = 440;
  static double pre_pwm_freq = 1000;
  for(int i = 0;i < uplimit;i++)
  {
    if ( (kasoku[i][0] <= inPWMFreq ) and ( inPWMFreq <= kasoku [i][1]))
    {
      //音色側
      //accel側とdecel側で分岐
      if(flag_sound_accel == true)
      {
          pwm_freq1 = (double)kasoku[i][2]
               + (double)(kasoku[i][3] - kasoku[i][2]) / (double)(kasoku [i][1] - kasoku [i][0])
               * (double)(inPWMFreq - kasoku [i][0]);
      }
      else
      {
        pwm_freq1 = (double)kasoku[i][4]
                 + (double)(kasoku[i][5] - kasoku[i][4]) / (double)(kasoku [i][1] - kasoku [i][0])
                 * (double)(inPWMFreq - kasoku [i][0]);
      }
    }  
  }
  //平滑化(時間で少しずつ近づける 33msecなので、0.3秒ほどで近づけようか？)
  pwm_freq_out = pre_pwm_freq + (pwm_freq1 - pre_pwm_freq) /10;
  //1000～1700ぐらいでやる感じにしようか　100%～170%としてkasoku.hも変えた。！
  pwm_add_dl = (pwm_freq_out * pow(2,SHIFT_PWM_DL)) / 1000 ;

  //格納しておく
  pre_pwm_freq = pwm_freq_out;
  return 0;
}



void VVVF_Init()//160917 fujigaya2 
{
  int cv47_Value = SoundSwitch;
  int cv48_Value = SoundState;
  //VVVF配列読み込み
  int kasoku_offset =  (int)pgm_read_word_near(&progmem_ref_kasoku[cv47_Value]);
  uplimit = (int)pgm_read_word_near(&progmem_ref_kasoku[cv47_Value+1]) - kasoku_offset;
  for(int i = 0;i < uplimit;i++)
  {
    for (int j = 0;j < 8;j++)
    {
      kasoku[i][j] =  (int)pgm_read_word_near(&progmem_kasoku [i + kasoku_offset][j]); 
    }
  }
}

//void vvvf_int1()
ISR(TIMER1_OVF_vect)
{
  //PORTD ^= _BV(PD7);
  //波形生成用interrupt
  static boolean flg = true;
  flg = !flg;
  if(flg)
  {
    //PORTD ^= _BV(PD7);
    return;
  }
  if (pwm_shift != 8)
  {
    unsigned int a;
    if(dl_flag == true)
    {
      //DL
      a = pgm_read_byte_near(&WAV_DATA_DL [pwm_state_dl >> SHIFT_PWM_DL]) * 4;
      pwm_state_dl += pwm_add_dl;
      if(pwm_state_dl >= ((unsigned long)(WAV_LENGTH_DL) << SHIFT_PWM_DL))
        pwm_state_dl -= ((unsigned long)(WAV_LENGTH_DL) << SHIFT_PWM_DL);          
    }
    else
    {
      //EL
      a = ((pgm_read_byte_near(&WAV_DATA1 [pwm_state1 >> SHIFT_PWM]) * 3 + pgm_read_byte_near(&WAV_DATA2 [pwm_state2 >> SHIFT_PWM])));
      pwm_state1 += pwm_add1;
      if((pwm_state1 >= (WAV_LENGTH1 << SHIFT_PWM)))
        pwm_state1 -= (WAV_LENGTH1 << SHIFT_PWM);
      pwm_state2 += pwm_add2;
      if((pwm_state2 >= (WAV_LENGTH2 << SHIFT_PWM)))
        pwm_state2 -= (WAV_LENGTH2 << SHIFT_PWM);
    }

    if (VVVF_SOUND_PIN == 9)
    {
      OCR1A=a>>(pwm_shift + 2);
    }
    else//(VVVF_SOUND_PIN == 10)
    {
      OCR1B=a>>(pwm_shift + 2);
    }

  }
  else
  {
    if (VVVF_SOUND_PIN == 9)
    {
      OCR1A=0;
    }
    else//(VVVF_SOUND_PIN == 10)
    {
      OCR1B=0;
    }
  }
  //
  //PORTD ^= _BV(PD7);
}
